当前位置:   article > 正文

C++:Leetcode-滑动窗口-209.长度最小的子数组_给定一个数组nums和滑动窗口的最小值 c++

给定一个数组nums和滑动窗口的最小值 c++

C++:Leetcode-滑动窗口-209.长度最小的子数组

方法一是暴力解法,即用两个for循环遍历找出所有的可能性,时间复杂度O(n2),超时
方法二是滑动窗口法,即本质是双指针法,不断的调节起始位置和终止位置,用一个for循环实现两个for的功能,时间复杂度O(n)
重点掌握滑动窗口法



题目

给定一个含有 n 个正整数的数组和一个正整数 target 。

找出该数组中满足其和 ≥ target 的长度最小的 连续子数组 [numsl, numsl+1, …, numsr-1, numsr] ,并返回其长度。如果不存在符合条件的子数组,返回 0 。


暴力解法

  • 两个for遍历所有情况,然后进行判断即可,此题采用了set容器,因为set存的数不会重复并会自动排序-
  • 但暴力解法会超时
/*
Leetcode-209长度最小数组-暴力解法
时间复杂度O(n2)

题目:
给定一个含有 n 个正整数的数组和一个正整数 target 。

找出该数组中满足其和 ≥ target 的长度最小的 连续子数组 [numsl, numsl+1, ..., numsr-1, numsr] ,并返回其长度。如果不存在符合条件的子数组,返回 0 。

来源:力扣(LeetCode)
链接:https://leetcode.cn/problems/minimum-size-subarray-sum
著作权归领扣网络所有。商业转载请联系官方授权,非商业转载请注明出处。


暴力解法时间超时!
*/

#include "iostream"
#include "vector"
#include "set"
using namespace std;

class Solution
{
public:
    int minSubArrayLen(int target, vector<int> &nums)
    {
        set<int> resMember;
        for (int i = 0; i < nums.size(); i++)
        {
            for (int j = i; j < nums.size(); j++)
            {
                int res = 0;
                if (i == j && nums[i] == target)
                {
                    return 1;
                }
                else
                {
                    for (int k = i; k <= j; k++)
                    {
                        res += nums[k];
                    }
                    if (res >= target) //找到符合target的先存下来
                    {
                        resMember.insert(j - i + 1);
                    }
                }
            }
        }
        //如果set容器的resMember有值,由于升序排序,返回begin()
        if (resMember.size() > 0)
        {
            return *resMember.begin();
        }
        //否则就是resMember为空,没有找到返回0
        else
        {
            return 0;
        }
    }
};

int main(int argc, char const *argv[])
{
    //测试!!!
    vector<int> nums;
    nums.push_back(2);
    nums.push_back(3);
    nums.push_back(1);
    nums.push_back(2);
    nums.push_back(4);
    nums.push_back(3);

    Solution s1;
    cout << s1.minSubArrayLen(2, nums) << endl;
    // for (vector<int>::iterator it = nums.begin(); it != nums.end(); it++)
    // {
    //     cout << *it << endl;
    // }
    return 0;
}

  • 1
  • 2
  • 3
  • 4
  • 5
  • 6
  • 7
  • 8
  • 9
  • 10
  • 11
  • 12
  • 13
  • 14
  • 15
  • 16
  • 17
  • 18
  • 19
  • 20
  • 21
  • 22
  • 23
  • 24
  • 25
  • 26
  • 27
  • 28
  • 29
  • 30
  • 31
  • 32
  • 33
  • 34
  • 35
  • 36
  • 37
  • 38
  • 39
  • 40
  • 41
  • 42
  • 43
  • 44
  • 45
  • 46
  • 47
  • 48
  • 49
  • 50
  • 51
  • 52
  • 53
  • 54
  • 55
  • 56
  • 57
  • 58
  • 59
  • 60
  • 61
  • 62
  • 63
  • 64
  • 65
  • 66
  • 67
  • 68
  • 69
  • 70
  • 71
  • 72
  • 73
  • 74
  • 75
  • 76
  • 77
  • 78
  • 79
  • 80
  • 81
  • 82
  • 83

滑动窗口法

滑动窗口,就是不断的调节子序列的起始位置和终止位置,从而得出我们要想的结果。
本质还是双指针
时间复杂度是O(n)

思路分析:

1 . 此代码重点理解for循环代表的是起始指针还是终止指针,如果代表是起始指针,那么终止指针还是一样要遍历跟两个for就没区别了,所以for变量j代表的是终止指针
2 .终止指针向后移动,直至sum+=nums[ j ]>=target,再进行判断此i到j区间内的最小子数组(i从0开始),i作为起始指针向后移动,sum = sum-nums[ i ],这样子来寻找最小子数组
3.不断跟新,直至终止指针移动至末端,起始指针也判断完毕
4.细节注意:因为找最小的子数组,所以result初始化一个很大的值,并且大于nums.size
(),因为最后的结果会有可能是nums.size(),因为后续还要进行判断;
也可以采用set容器进行存储值

/*
Leetcode-209-滑动窗口解法本质也是双指针解法
利用一个for循环实现两个for的功能
重点理解for循环代表的是起始指针还是终止指针

思路分析:
1.for循环变量j代表终止指针,若代表起始指针,那么终止指针的移动将跟两个for的情况相同,无法提高效率
2.终止指针向后移动,不断累加sum+=nums[j],直至sum>=target
3.再从此时的起始指针到终止指针i区间进行接着寻找sum>=target的最小子数组
4.不断跟新,直至终止指针移动至末端,起始指针也判断完毕

时间复杂度O(n)
*/

#include "iostream"
#include "vector"
#include "set"
using namespace std;

class Solution
{
public:
    int minSubArrayLen(int target, vector<int> &nums)
    {
        int sum = 0;
        // set<int> res;
        int result = nums.size() + 1;
        int subLen;
        int i = 0;
        for (int j = 0; j < nums.size(); j++)
        {
            sum += nums[j];
            //找到sum>=target区间,开始寻找最小子数组
            while (sum >= target)
            {
                subLen = j - i + 1; //此处出现bug!!!!!!!!!!会出现负数!!!
                                    //   res.insert(subLen);//存set容器中
                result = result > subLen ? subLen : result;
                sum = sum - nums[i];
                i++;
            }
        }
        // return *res.begin();
        return result == (nums.size() + 1) ? 0 : result;
    }
};

int main(int argc, char const *argv[])
{
    //测试!!!
    vector<int> nums;
    nums.push_back(2);
    nums.push_back(3);
    nums.push_back(1);
    nums.push_back(2);
    nums.push_back(4);
    nums.push_back(3);

    Solution s1;
    cout << s1.minSubArrayLen(2, nums) << endl;
    // for (vector<int>::iterator it = nums.begin(); it != nums.end(); it++)
    // {
    //     cout << *it << endl;
    // }    return 0;
}

  • 1
  • 2
  • 3
  • 4
  • 5
  • 6
  • 7
  • 8
  • 9
  • 10
  • 11
  • 12
  • 13
  • 14
  • 15
  • 16
  • 17
  • 18
  • 19
  • 20
  • 21
  • 22
  • 23
  • 24
  • 25
  • 26
  • 27
  • 28
  • 29
  • 30
  • 31
  • 32
  • 33
  • 34
  • 35
  • 36
  • 37
  • 38
  • 39
  • 40
  • 41
  • 42
  • 43
  • 44
  • 45
  • 46
  • 47
  • 48
  • 49
  • 50
  • 51
  • 52
  • 53
  • 54
  • 55
  • 56
  • 57
  • 58
  • 59
  • 60
  • 61
  • 62
  • 63
  • 64
  • 65
  • 66

总结

重点掌握熟悉滑动窗口法,知道各自指针意义。
参考代码随想录https://www.programmercarl.com/0209.%E9%95%BF%E5%BA%A6%E6%9C%80%E5%B0%8F%E7%9A%84%E5%AD%90%E6%95%B0%E7%BB%84.html#%E6%BB%91%E5%8A%A8%E7%AA%97%E5%8F%A3

声明:本文内容由网友自发贡献,不代表【wpsshop博客】立场,版权归原作者所有,本站不承担相应法律责任。如您发现有侵权的内容,请联系我们。转载请注明出处:https://www.wpsshop.cn/w/从前慢现在也慢/article/detail/401186
推荐阅读
相关标签
  

闽ICP备14008679号